<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.linalg;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import ch.javasoft.math.array.ArrayOperations;<a name="line.36"></a>
<FONT color="green">037</FONT>    import ch.javasoft.math.array.NumberArrayOperations;<a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.math.array.NumberOperators;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.math.operator.TernaryOperator;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.util.IntArray;<a name="line.40"></a>
<FONT color="green">041</FONT>    <a name="line.41"></a>
<FONT color="green">042</FONT>    /**<a name="line.42"></a>
<FONT color="green">043</FONT>     * The &lt;code&gt;SupportBasicLinAlgOperations&lt;/code&gt; class implements<a name="line.43"></a>
<FONT color="green">044</FONT>     * {@link BasicLinAlgOperations} based on an instance of <a name="line.44"></a>
<FONT color="green">045</FONT>     * {@link NumberArrayOperations}. It uses bitwise support vectors to exploit<a name="line.45"></a>
<FONT color="green">046</FONT>     * sparse matrices for operations of matrix multiplication type.<a name="line.46"></a>
<FONT color="green">047</FONT>     * <a name="line.47"></a>
<FONT color="green">048</FONT>     * @type N      the number type of a single number<a name="line.48"></a>
<FONT color="green">049</FONT>     * @type A      the number type of an array of numbers<a name="line.49"></a>
<FONT color="green">050</FONT>     */<a name="line.50"></a>
<FONT color="green">051</FONT>    public class SupportBasicLinAlgOperations&lt;N extends Number, A&gt; extends DefaultBasicLinAlgOperations&lt;N, A&gt; {<a name="line.51"></a>
<FONT color="green">052</FONT>            <a name="line.52"></a>
<FONT color="green">053</FONT>            public SupportBasicLinAlgOperations(NumberOperators&lt;N, A&gt; numberOps, ArrayOperations&lt;A&gt; arrayOps) {<a name="line.53"></a>
<FONT color="green">054</FONT>                    super(numberOps, arrayOps);<a name="line.54"></a>
<FONT color="green">055</FONT>            }<a name="line.55"></a>
<FONT color="green">056</FONT>            public SupportBasicLinAlgOperations(NumberArrayOperations&lt;N, A&gt; numberArrayOps) {<a name="line.56"></a>
<FONT color="green">057</FONT>                    super(numberArrayOps);<a name="line.57"></a>
<FONT color="green">058</FONT>            }<a name="line.58"></a>
<FONT color="green">059</FONT>            public SupportBasicLinAlgOperations(BasicLinAlgOperations&lt;N, A&gt; basicLinAlgOps) {<a name="line.59"></a>
<FONT color="green">060</FONT>                    super(basicLinAlgOps.getNumberArrayOperations());<a name="line.60"></a>
<FONT color="green">061</FONT>            }<a name="line.61"></a>
<FONT color="green">062</FONT>    <a name="line.62"></a>
<FONT color="green">063</FONT>            @Override<a name="line.63"></a>
<FONT color="green">064</FONT>            public A[] multiply(A[] m1, A[] m2) {<a name="line.64"></a>
<FONT color="green">065</FONT>                    final int rows1 = arrayOps.getRowCount(m1);<a name="line.65"></a>
<FONT color="green">066</FONT>                    final int cols1 = arrayOps.getColumnCount(m1);<a name="line.66"></a>
<FONT color="green">067</FONT>                    final int rows2 = arrayOps.getRowCount(m2);<a name="line.67"></a>
<FONT color="green">068</FONT>                    final int cols2 = arrayOps.getColumnCount(m2);<a name="line.68"></a>
<FONT color="green">069</FONT>                    if (cols1 != rows2) {<a name="line.69"></a>
<FONT color="green">070</FONT>                            throw new IllegalArgumentException("incompatible dimension for matrix multiplication: " + rows1 + "x" + cols1 + " * " + rows2 + "x" + cols2);<a name="line.70"></a>
<FONT color="green">071</FONT>                    }<a name="line.71"></a>
<FONT color="green">072</FONT>                    final TernaryOperator&lt;N, A&gt; mulAdd = expressionComposer.addToFree(expressionComposer.mul());<a name="line.72"></a>
<FONT color="green">073</FONT>                    <a name="line.73"></a>
<FONT color="green">074</FONT>                    final A[] res = numberArrayOps.newZeroMatrix(rows1, cols2);<a name="line.74"></a>
<FONT color="green">075</FONT>                    <a name="line.75"></a>
<FONT color="green">076</FONT>                    IntArray indices = null;                <a name="line.76"></a>
<FONT color="green">077</FONT>                    final long[][] rsup = numberArrayOps.getMatrixSupportAsLongBits(m1);<a name="line.77"></a>
<FONT color="green">078</FONT>                    for (int c = 0; c &lt; cols2; c++) {<a name="line.78"></a>
<FONT color="green">079</FONT>                            final long[] csup = numberArrayOps.getMatrixColumnSupportAsLongBits(m2, c);<a name="line.79"></a>
<FONT color="green">080</FONT>                            for (int r = 0; r &lt; rows1; r++) {<a name="line.80"></a>
<FONT color="green">081</FONT>                                    indices = toIndexArray(rsup[r], csup, indices);<a name="line.81"></a>
<FONT color="green">082</FONT>                                    for (int i = 0; i &lt; indices.length(); i++) {<a name="line.82"></a>
<FONT color="green">083</FONT>                                            final int index = indices.get(i);<a name="line.83"></a>
<FONT color="green">084</FONT>                                            //res[r][c] = res[r][c] + m1[r][index]*m2[index][c]<a name="line.84"></a>
<FONT color="green">085</FONT>                                            mulAdd.operate(res[r], c, m1[r], index, m2[index], c, res[r], c);<a name="line.85"></a>
<FONT color="green">086</FONT>                                    }<a name="line.86"></a>
<FONT color="green">087</FONT>                            }<a name="line.87"></a>
<FONT color="green">088</FONT>                    }<a name="line.88"></a>
<FONT color="green">089</FONT>                    return res;<a name="line.89"></a>
<FONT color="green">090</FONT>            }<a name="line.90"></a>
<FONT color="green">091</FONT>            <a name="line.91"></a>
<FONT color="green">092</FONT>            private static IntArray toIndexArray(long[] supportA, long[] supportB, IntArray indices) {<a name="line.92"></a>
<FONT color="green">093</FONT>                    if (indices == null) {<a name="line.93"></a>
<FONT color="green">094</FONT>                            indices = new IntArray();<a name="line.94"></a>
<FONT color="green">095</FONT>                    }<a name="line.95"></a>
<FONT color="green">096</FONT>                    else {<a name="line.96"></a>
<FONT color="green">097</FONT>                            indices.clear();<a name="line.97"></a>
<FONT color="green">098</FONT>                    }<a name="line.98"></a>
<FONT color="green">099</FONT>                    for (int i = 0; i &lt; supportA.length; i++) {<a name="line.99"></a>
<FONT color="green">100</FONT>                            long commonSupport = supportA[i] &amp; supportB[i];<a name="line.100"></a>
<FONT color="green">101</FONT>                            while (commonSupport != 0) {<a name="line.101"></a>
<FONT color="green">102</FONT>                                    final int index = Long.numberOfTrailingZeros(commonSupport);<a name="line.102"></a>
<FONT color="green">103</FONT>                                    indices.add(index + i*64);<a name="line.103"></a>
<FONT color="green">104</FONT>                                    commonSupport ^= (1L &lt;&lt; index);<a name="line.104"></a>
<FONT color="green">105</FONT>                            }<a name="line.105"></a>
<FONT color="green">106</FONT>                    }<a name="line.106"></a>
<FONT color="green">107</FONT>                    return indices;<a name="line.107"></a>
<FONT color="green">108</FONT>            }<a name="line.108"></a>
<FONT color="green">109</FONT>    <a name="line.109"></a>
<FONT color="green">110</FONT>            @Override<a name="line.110"></a>
<FONT color="green">111</FONT>            public A multiply(A[] m, A v) {<a name="line.111"></a>
<FONT color="green">112</FONT>                    final int rows1 = arrayOps.getRowCount(m);<a name="line.112"></a>
<FONT color="green">113</FONT>                    final int cols1 = arrayOps.getColumnCount(m);<a name="line.113"></a>
<FONT color="green">114</FONT>                    final int rows2 = arrayOps.getLength(v);<a name="line.114"></a>
<FONT color="green">115</FONT>                    if (cols1 != rows2) {<a name="line.115"></a>
<FONT color="green">116</FONT>                            throw new IllegalArgumentException("incompatible dimension for matrix multiplication: " + rows1 + "x" + cols1 + " * " + rows2 + "x1");<a name="line.116"></a>
<FONT color="green">117</FONT>                    }<a name="line.117"></a>
<FONT color="green">118</FONT>                    final TernaryOperator&lt;N, A&gt; mulAdd = expressionComposer.addToFree(expressionComposer.mul());<a name="line.118"></a>
<FONT color="green">119</FONT>                    <a name="line.119"></a>
<FONT color="green">120</FONT>                    final A res = numberArrayOps.newZeroVector(rows1);<a name="line.120"></a>
<FONT color="green">121</FONT>    <a name="line.121"></a>
<FONT color="green">122</FONT>                    IntArray indices = null; <a name="line.122"></a>
<FONT color="green">123</FONT>                    final long[] csup = numberArrayOps.getVectorSupportAsLongBits(v);<a name="line.123"></a>
<FONT color="green">124</FONT>                    for (int r = 0; r &lt; rows1; r++) {<a name="line.124"></a>
<FONT color="green">125</FONT>                            final long[] rsup = numberArrayOps.getMatrixRowSupportAsLongBits(m, r);<a name="line.125"></a>
<FONT color="green">126</FONT>                            indices = toIndexArray(rsup, csup, indices);<a name="line.126"></a>
<FONT color="green">127</FONT>                            for (int i = 0; i &lt; indices.length(); i++) {<a name="line.127"></a>
<FONT color="green">128</FONT>                                    final int index = indices.get(i);<a name="line.128"></a>
<FONT color="green">129</FONT>                                    //res[r] = res[r] + m[r][index]*v[index]<a name="line.129"></a>
<FONT color="green">130</FONT>                                    mulAdd.operate(res, r, m[r], index, v, index, res, r);<a name="line.130"></a>
<FONT color="green">131</FONT>                            }<a name="line.131"></a>
<FONT color="green">132</FONT>                    }<a name="line.132"></a>
<FONT color="green">133</FONT>                    return res;<a name="line.133"></a>
<FONT color="green">134</FONT>            }<a name="line.134"></a>
<FONT color="green">135</FONT>    <a name="line.135"></a>
<FONT color="green">136</FONT>            @Override<a name="line.136"></a>
<FONT color="green">137</FONT>            public A multiply(A v, A[] m) {<a name="line.137"></a>
<FONT color="green">138</FONT>                    final int cols1 = arrayOps.getLength(v);<a name="line.138"></a>
<FONT color="green">139</FONT>                    final int rows2 = arrayOps.getRowCount(m);<a name="line.139"></a>
<FONT color="green">140</FONT>                    final int cols2 = arrayOps.getColumnCount(m);<a name="line.140"></a>
<FONT color="green">141</FONT>                    if (cols1 != rows2) {<a name="line.141"></a>
<FONT color="green">142</FONT>                            throw new IllegalArgumentException("incompatible dimension for matrix multiplication: " + "1x" + cols1 + " * " + rows2 + "x" + cols2);<a name="line.142"></a>
<FONT color="green">143</FONT>                    }<a name="line.143"></a>
<FONT color="green">144</FONT>                    final TernaryOperator&lt;N, A&gt; mulAdd = expressionComposer.addToFree(expressionComposer.mul());<a name="line.144"></a>
<FONT color="green">145</FONT>            <a name="line.145"></a>
<FONT color="green">146</FONT>                    final A res = numberArrayOps.newZeroVector(cols2);<a name="line.146"></a>
<FONT color="green">147</FONT>                    <a name="line.147"></a>
<FONT color="green">148</FONT>                    IntArray indices = null; <a name="line.148"></a>
<FONT color="green">149</FONT>                    final long[] rsup = numberArrayOps.getVectorSupportAsLongBits(v);<a name="line.149"></a>
<FONT color="green">150</FONT>                    for (int c = 0; c &lt; cols2; c++) {<a name="line.150"></a>
<FONT color="green">151</FONT>                            final long[] csup = numberArrayOps.getMatrixColumnSupportAsLongBits(m, c);<a name="line.151"></a>
<FONT color="green">152</FONT>                            indices = toIndexArray(rsup, csup, indices);<a name="line.152"></a>
<FONT color="green">153</FONT>                            for (int i = 0; i &lt; indices.length(); i++) {<a name="line.153"></a>
<FONT color="green">154</FONT>                                    final int index = indices.get(i);<a name="line.154"></a>
<FONT color="green">155</FONT>                                    //res[c] = res[c] + v[index]*m[index][c]*<a name="line.155"></a>
<FONT color="green">156</FONT>                                    mulAdd.operate(res, c, v, index, m[index], c, res, c);<a name="line.156"></a>
<FONT color="green">157</FONT>                            }<a name="line.157"></a>
<FONT color="green">158</FONT>                    }<a name="line.158"></a>
<FONT color="green">159</FONT>                    return res;<a name="line.159"></a>
<FONT color="green">160</FONT>            }<a name="line.160"></a>
<FONT color="green">161</FONT>    <a name="line.161"></a>
<FONT color="green">162</FONT>    }<a name="line.162"></a>




























































</PRE>
</BODY>
</HTML>
